Debian Bug report logs - #386121
libstdc++6: Incompatibility with older libgcc_s.so.1

version graph

Package: libstdc++6; Maintainer for libstdc++6 is Debian GCC Maintainers <debian-gcc@lists.debian.org>; Source for libstdc++6 is src:gcc-4.9.

Reported by: Stefan Bellon <sbellon@sbellon.de>

Date: Tue, 5 Sep 2006 12:33:01 UTC

Severity: important

Merged with 402105

Found in version gcc-4.1/4.1.1ds1-13

Done: Matthias Klose <doko@cs.tu-berlin.de>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#386121; Package libstdc++6. Full text and rfc822 format available.

Acknowledgement sent to Stefan Bellon <sbellon@sbellon.de>:
New Bug report received and forwarded. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Stefan Bellon <sbellon@sbellon.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: libstdc++6: Incompatibility with older libgcc_s.so.1
Date: Tue, 05 Sep 2006 14:15:24 +0200
Package: libstdc++6
Version: 4.1.1-13
Severity: important


I have problems with version 4.1.1ds1-13 of package libstdc++6 as this
breaks some older applications. If you have the sources, you can
recompile, if not ... what is the suggested solution?

What happens is this:

sbellon@io$ ldd foobar
./foobar: /usr/local/gnat/lib/libgcc_s.so.1: version `GCC_4.2.0' not
found (required by /usr/lib/libstdc++.so.6)

This looks to me like the new library demands version GCC_4.2.0 from
libgcc_s.so.1, which in my case cannot provide this. How can I get
foobar going with the new libstdc++? I can recompile foobar as I have
the sources to it, but I cannot easily
recompile /usr/local/gnat/lib/libgcc_s.so.1 which foobar depends on
(this is from AdaCore's binary distribution of GNAT).

With the 4.1.1ds1-13, it looks like this:

sbellon@io$ strings /usr/lib/libstdc++.so.6 | grep ^GCC
GCC_3.3
GCC_4.2.0
GCC_3.0
sbellon@io$ 

With 4.1.1-11 everything was fine:

bellonsn@cube$ strings /usr/lib/libstdc++.so.6 | grep ^GCC
GCC_3.3
GCC_3.0
bellonsn@cube$

Why was this dependency introduced? Is there any way around it?

In the libgcc_s.so.1 supplied by AdaCore, it looks like this:

bellonsn@cube$ strings /usr/local/gnat/lib/libgcc_s.so.1 | grep ^GCC
GCC_3.0
GCC_3.3
GCC_3.3.1
GCC_3.4
GCC_3.4.2

Is this a change in libstdc++6 that will become necessary in the future
anyway and there's no way round it, or is it a bug in the latest version
of the libstdc++6 package?

Thanks for any hints in advance.


-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: i386 (i686)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.17
Locale: LANG=en_US, LC_CTYPE=de_DE (charmap=ANSI_X3.4-1968) (ignored: LC_ALL set to C)

Versions of packages libstdc++6 depends on:
ii  gcc-4.1-base                 4.1.1-13    The GNU Compiler Collection (base 
ii  libc6                        2.3.6.ds1-4 GNU C Library: Shared libraries
ii  libgcc1                      1:4.1.1-13  GCC support library

libstdc++6 recommends no packages.

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#386121; Package libstdc++6. Full text and rfc822 format available.

Acknowledgement sent to Nick Lewycky <nicholas@mxc.ca>:
Extra info received and forwarded to list. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>.

Your message did not contain a Subject field. They are recommended and useful because the title of a Bug is determined using this field. Please remember to include a Subject field in your messages in future.

Full text and rfc822 format available.


Message #10 received at 386121@bugs.debian.org (full text, mbox):

From: Nick Lewycky <nicholas@mxc.ca>
To: 386121@bugs.debian.org
Date: Thu, 07 Sep 2006 00:24:10 -0400
I'm seeing this when rebuilding LLVM or Wine. This bug doesn't appear to
go away when rebuilding from source.

Or else it's possible that the newly compiled software is being linked
with C++ libraries that are triggering the problem, in which case, this
bug is some form of C++ ABI breakage without an associated so-version bump.

Nick Lewycky




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#386121; Package libstdc++6. Full text and rfc822 format available.

Acknowledgement sent to Nach <nachms@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 386121@bugs.debian.org (full text, mbox):

From: Nach <nachms@gmail.com>
To: 386121@bugs.debian.org
Subject: This Stupid Bug
Date: Mon, 25 Sep 2006 14:10:30 +0300
[Message part 1 (text/plain, inline)]
I'm experiencing the same problem. It's driving me crazy that I can't run
WINE anymore on most of my apps.

err:module:load_builtin_dll failed to load .so lib for builtin L"gdi32.dll":
/usr/local/lib/libgcc_s.so.1: version `GCC_4.2.0' not found (required by
/usr/bin/../lib/libstdc++.so.6)
err:module:import_dll Loading library gdi32.dll (which is needed by
L"c:\\windows\\system32\\user32.dll") failed (error c000007a).
err:module:import_dll Library user32.dll (which is needed by
L"c:\\windows\\system32\\winmm.dll") not found

And it just goes downhill from there.
[Message part 2 (text/html, inline)]

Reply sent to Matthias Klose <doko@cs.tu-berlin.de>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Stefan Bellon <sbellon@sbellon.de>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #20 received at 386121-done@bugs.debian.org (full text, mbox):

From: Matthias Klose <doko@cs.tu-berlin.de>
To: Stefan Bellon <sbellon@sbellon.de>, Nick Lewycky <nicholas@mxc.ca>, Nach <nachms@gmail.com>, 386121-done@bugs.debian.org
Subject: Re: Bug#386121: libstdc++6: Incompatibility with older libgcc_s.so.1
Date: Sat, 7 Oct 2006 16:09:29 +0200
Stefan Bellon writes:
> Package: libstdc++6
> Version: 4.1.1-13
> Severity: important
> 
> 
> I have problems with version 4.1.1ds1-13 of package libstdc++6 as this
> breaks some older applications. If you have the sources, you can
> recompile, if not ... what is the suggested solution?
> 
> What happens is this:
> 
> sbellon@io$ ldd foobar
> ./foobar: /usr/local/gnat/lib/libgcc_s.so.1: version `GCC_4.2.0' not
> found (required by /usr/lib/libstdc++.so.6)
> 
> This looks to me like the new library demands version GCC_4.2.0 from
> libgcc_s.so.1, which in my case cannot provide this. How can I get
> foobar going with the new libstdc++? I can recompile foobar as I have
> the sources to it, but I cannot easily
> recompile /usr/local/gnat/lib/libgcc_s.so.1 which foobar depends on
> (this is from AdaCore's binary distribution of GNAT).

Not a bug; you're using a locally installed libgcc_s.so.1 on your
system, which doesn't have this symbol.

Debian's libstdc++6 explicitely depends on libgcc1 (>= 1:4.1.1-12),
which provides this symbol.



Message #21 received at 386121-done@bugs.debian.org (full text, mbox):

From: Stefan Bellon <sbellon@sbellon.de>
To: Matthias Klose <doko@cs.tu-berlin.de>
Cc: nicholas@mxc.ca, nachms@gmail.com, 386121-done@bugs.debian.org
Subject: Re: Bug#386121: libstdc++6: Incompatibility with older libgcc_s.so.1
Date: Sat, 07 Oct 2006 16:21:55 +0200
On 07 Oct, you wrote:
> Stefan Bellon writes:

> > This looks to me like the new library demands version GCC_4.2.0
> > from libgcc_s.so.1, which in my case cannot provide this. How can I
> > get foobar going with the new libstdc++? I can recompile foobar as
> > I have the sources to it, but I cannot easily recompile
> > /usr/local/gnat/lib/libgcc_s.so.1 which foobar depends on (this is
> > from AdaCore's binary distribution of GNAT).

> Not a bug; you're using a locally installed libgcc_s.so.1 on your
> system, which doesn't have this symbol.

Yes, I know, this is not what I think is the bug ...

> Debian's libstdc++6 explicitely depends on libgcc1 (>= 1:4.1.1-12),
> which provides this symbol.

... the bug is in my opinion the fact, that a 4.1 version demands the
symbol GCC_4.2.0 which should only be necessary in a 4.2 version. So,
if I have a locally installed libgcc_s.so.1 which "normally" is quite
fine with a Debian installed libstdc++6, then this change breaks this.

-- 
Stefan Bellon



Message #22 received at 386121-done@bugs.debian.org (full text, mbox):

From: "Duncan Smith" <slimey.limey@gmail.com>
To: 386121-done@bugs.debian.org
Subject: This very irritating bug
Date: Thu, 19 Oct 2006 20:59:21 -0700
Hey, I know this isn't exactly related to fixing the bug, so sorry in advance.

I'm not using any local libgcc_s.so.1, but my system is running
Unstable.  I keep it offline usually for months at a time, connecting
to update at random intervals.  I updated a few weeks ago and
libstdc++6 was upgraded, and it broke just about everything because
libgcc1 (>= 1:4.2.???, a version with the symbol GCC_4.2.0) was not
available for some reason.

So my system's been wedged since then.  Thankfully I've got another
machine, but I'd really like to see some action here.

I love Debian, though.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#386121; Package libstdc++6. Full text and rfc822 format available.

Acknowledgement sent to Nach <nachms@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>. Full text and rfc822 format available.

Message #27 received at 386121@bugs.debian.org (full text, mbox):

From: Nach <nachms@gmail.com>
To: 386121@bugs.debian.org
Subject: This bug *is* Debian's fault
Date: Thu, 16 Nov 2006 18:37:04 +0200
[Message part 1 (text/plain, inline)]
After being annoyed about WINE not working for over a month now, I decided
to do some more checking into this.

I downloaded libstdc++6_4.1.1-19_i386.deb directly off the Debian servers
here:
http://packages.debian.org/cgi-bin/download.pl?arch=i386&file=pool%2Fmain%2Fg%2Fgcc-4.1%2Flibstdc%2B%2B6_4.1.1-19_i386.deb&md5sum=d848d8c4db5f9ebe3ffdab58be476ee5&arch=i386&type=main

I then opened the deb file with Ark and extracted all the contents, a grep
of libstdc++6.0.8 is showing it depends on GCC_4.2.0 this is breaking many
applications and GCC 4.2 is NOT out yet. Can someone please fix this?
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#386121; Package libstdc++6. Full text and rfc822 format available.

Acknowledgement sent to Matthias Klose <doko@cs.tu-berlin.de>:
Extra info received and forwarded to list. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>. Full text and rfc822 format available.

Message #32 received at 386121@bugs.debian.org (full text, mbox):

From: Matthias Klose <doko@cs.tu-berlin.de>
To: Nach <nachms@gmail.com>, 386121@bugs.debian.org
Subject: Re: Bug#386121: This bug *is* Debian's fault
Date: Thu, 16 Nov 2006 18:57:53 +0100
There is nothing to fix. You are using a libgcc which doesn't contain
the backported symbol. It should be safe to just remove that libgcc
version.

Nach writes:
> After being annoyed about WINE not working for over a month now, I decided
> to do some more checking into this.
> 
> I downloaded libstdc++6_4.1.1-19_i386.deb directly off the Debian servers
> here:
> http://packages.debian.org/cgi-bin/download.pl?arch=i386&file=pool%2Fmain%2Fg%2Fgcc-4.1%2Flibstdc%2B%2B6_4.1.1-19_i386.deb&md5sum=d848d8c4db5f9ebe3ffdab58be476ee5&arch=i386&type=main
> 
> I then opened the deb file with Ark and extracted all the contents, a grep
> of libstdc++6.0.8 is showing it depends on GCC_4.2.0 this is breaking many
> applications and GCC 4.2 is NOT out yet. Can someone please fix this?
> After being annoyed about WINE not working for over a month now, I decided to do some more checking into this.<br><br>I downloaded libstdc++6_4.1.1-19_i386.deb directly off the Debian servers here: <a href="http://packages.debian.org/cgi-bin/download.pl?arch=i386&amp;file=pool%2Fmain%2Fg%2Fgcc-4.1%2Flibstdc%2B%2B6_4.1.1-19_i386.deb&amp;md5sum=d848d8c4db5f9ebe3ffdab58be476ee5&amp;arch=i386&amp;type=main">
> http://packages.debian.org/cgi-bin/download.pl?arch=i386&amp;file=pool%2Fmain%2Fg%2Fgcc-4.1%2Flibstdc%2B%2B6_4.1.1-19_i386.deb&amp;md5sum=d848d8c4db5f9ebe3ffdab58be476ee5&amp;arch=i386&amp;type=main</a><br><br>I then opened the deb file with Ark and extracted all the contents, a grep of libstdc++6.0.8 is showing it depends on GCC_4.2.0 this is breaking many applications and GCC 
> 4.2 is NOT out yet. Can someone please fix this?<br>



Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#386121; Package libstdc++6. Full text and rfc822 format available.

Acknowledgement sent to Duncan Smith <slimey.limey@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>. Full text and rfc822 format available.

Message #37 received at 386121@bugs.debian.org (full text, mbox):

From: Duncan Smith <slimey.limey@gmail.com>
To: Matthias Klose <doko@cs.tu-berlin.de>
Cc: 386121@bugs.debian.org
Subject: Re: Bug#386121: This bug *is* Debian's fault
Date: Mon, 20 Nov 2006 21:28:36 -0800
On Thu, Nov 16, 2006 at 06:57:53PM +0100, Matthias Klose wrote:
> There is nothing to fix. You are using a libgcc which doesn't
> contain the backported symbol. It should be safe to just remove that
> libgcc version.

The system on which I'm experiencing this bug has some serious
dependency issues.  I'm doing a dist-upgrade now, and when I've got it
working smoothly again I'll report whether the bug shows up.

-- 
Duncan Smith
http://students.washington.edu/f/
Please sign and encrypt your mail if it is at all possible.



Forcibly Merged 386121 402105. Request was from Jeremy Lainé <jeremy.laine@m4x.org> to control@bugs.debian.org. Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 17 Jun 2007 11:46:43 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 15:56:22 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.